//============================================================================
// Name        : AbstractFactory.cpp
// Description : Example of Abstract Factory Design Pattern
//============================================================================

#include <iostream>
#include <memory>

#include "WidgetFactory.h"
#include "WinFactory.h"
#include "GTKFactory.h"
#include "Widget.h"
using namespace std;

int main() {
	WidgetFactory* factory;

#ifdef __WIN
	factory = WinFactory::getFactory();
#else
	factory = GTKFactory::getFactory();
#endif

	// crea bottone e finestra dalla factory
	unique_ptr<WidgetButton> button = unique_ptr<WidgetButton>(factory->createButton("My Button"));
	unique_ptr<WidgetWindow> window = unique_ptr<WidgetWindow>(factory->createWindow("My Window Title"));

	window->draw();
	button->draw();
	button->click();
	window->move(12, 34);

	return 0;
}
