/*
 * WinFactory.cpp
 *
 */

#include "WinFactory.h"
#include "WinButton.h"
#include "WinWindow.h"

WinFactory* WinFactory::factory = 0;

WidgetFactory* WinFactory::getFactory() {
	if( factory == 0 ) {
		factory = new WinFactory;
	}
	return factory;
}

WinFactory::WinFactory() {
	// possible constructor
}

WinFactory::~WinFactory() {
	// possible destructor
}

WidgetButton* WinFactory::createButton(std::string text) {
	return new WinButton(text);
}

WidgetWindow* WinFactory::createWindow(std::string title) {
	return new WinWindow(title);
}
